      **********************************************************************
      *      Mode Flags.
      *         basically, the mode parm of open(), creat(), chmod(),etc
      *         uses 9 least significant bits to determine the
      *         file's mode. (peoples access rights to the file)
      *
      *           user:       owner    group    other
      *           access:     R W X    R W X    R W X
      *           bit:        8 7 6    5 4 3    2 1 0
      *
      * (This is accomplished by adding the flags below to get the mode)
      **********************************************************************
      *                                         owner authority
     D S_IRUSR         C                   256
     D S_IWUSR         C                   128
     D S_IXUSR         C                   64
     D S_IRWXU         C                   448
      *                                         group authority
     D S_IRGRP         C                   32
     D S_IWGRP         C                   16
     D S_IXGRP         C                   8
     D S_IRWXG         C                   56
      *                                         other people
     D S_IROTH         C                   4
     D S_IWOTH         C                   2
     D S_IXOTH         C                   1
     D S_IRWXO         C                   7


     D CRLF            C                   x'0d25'


      **********************************************************************
      *  Flags for use in open()
      *
      * More than one can be used -- add them together.
      **********************************************************************
      *                                            Reading Only
     D O_RDONLY        C                   1
      *                                            Writing Only
     D O_WRONLY        C                   2
      *                                            Reading & Writing
     D O_RDWR          C                   4
      *                                            Create File if not exist
     D O_CREAT         C                   8
      *                                            Exclusively create
     D O_EXCL          C                   16
      *                                            Truncate File to 0 bytes
     D O_TRUNC         C                   64
      *                                            Append to File
     D O_APPEND        C                   256
      *                                            Convert text by code-page
     D O_CODEPAGE      C                   8388608
      *                                            Open in text-mode
     D O_TEXTDATA      C                   16777216


      *
      * Stream file processing prototypes
      *
     D open            PR            10I 0 extproc('open')
     D   path                          *   value options(*string)
     D   oflag                       10I 0 value
     D   mode                        10U 0 value options(*nopass)
     D   codepage                    10U 0 value options(*nopass)
      *
     D close           PR            10I 0 extproc('close')
     D   fildes                      10I 0 value
      *
     D write           PR            10I 0 extproc('write')
     D   fildes                      10I 0 value
     D   buf                           *   value
     D   nbyte                       10U 0 value
      *
     D read            PR            10I 0 extproc('read')
     D   fildes                      10I 0 value
     D   buf                           *   value
     D   nbyte                       10U 0 value
      *
     D access          PR            10I 0 extproc('access')
     D   path                          *   value options(*string)
     D   amode                       10I 0 value


      **********************************************************************
      * Access mode flags for access()
      *
      *   F_OK = File Exists
      *   R_OK = Read Access
      *   W_OK = Write Access
      *   X_OK = Execute or Search
      **********************************************************************
     D F_OK            C                   0
     D R_OK            C                   4
     D W_OK            C                   2
     D X_OK            C                   1

